
import * as $calcit from "./calcit.core.mjs";
import { component_$q_ } from "./respo.util.detect.mjs";
import { effect_$q_ } from "./respo.util.detect.mjs";
import { element_$q_ } from "./respo.util.detect.mjs";
import { pick_attrs } from "./respo.util.list.mjs";
import { pick_event } from "./respo.util.list.mjs";
import * as $respo_DOT_schema from "./respo.schema.mjs";
import { val_exists_$q_ } from "./respo.util.list.mjs";
var _kwd={};
["a","attrs","body","children","class-name","coord","div","effects","event","head","html","inner-text","link","name","span","style","tree",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function confirm_child(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('confirm-child', 1, arguments.length);
(function __fn__(){
( $calcit.not($calcit.string_$q_("Invalid data in elements tree: ")) ? (function __fn__(){
let err_AUTO_1 = new Error("expects 1st argument to be string");
 err_AUTO_1.data = null;
 throw err_AUTO_1;
})() : null );

if ((function __fn__(){
let v1__2 = $calcit.nil_$q_(x);

if ($calcit.nil_$q_(v1__2)) { let v1__3 = element_$q_(x);

if ($calcit.nil_$q_(v1__3)) { return component_$q_(x) }
 else if ($calcit._$e_(false, v1__3)) { return component_$q_(x) }else { return v1__3 }
 }
 else if ($calcit._$e_(false, v1__2)) { let v1__4 = element_$q_(x);

if ($calcit.nil_$q_(v1__4)) { return component_$q_(x) }
 else if ($calcit._$e_(false, v1__4)) { return component_$q_(x) }else { return v1__4 }
 }else { return v1__2 }

})()) { return null }else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("or"), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("nil?"), new $calcit.CalcitSymbol("x")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("element?"), new $calcit.CalcitSymbol("x")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("component?"), new $calcit.CalcitSymbol("x")])]))));
let err_AUTO_2 = new Error("Invalid data in elements tree:  (or (nil? x) (element? x) (component? x))");
 err_AUTO_2.data = null;
 throw err_AUTO_2;
 }

})();
return x
}
export function create_element(tag_name, props, ...children) { 
if (arguments.length < 2) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
let attrs = pick_attrs(props);
let styles = $calcit.sort($calcit.invoke_method("to-list",(function __fn__(){
let v1__1 = $calcit.get(props, _kwd["style"]);

if ($calcit.nil_$q_(v1__1)) { return $calcit._$n__$M_() }else { return v1__1 }

})(),), function f_PCT_(x, y) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit._$n_compare($calcit.first(x), $calcit.first(y))
}
);
let event = pick_event(props);
let children_nodes = $calcit.filter($calcit.map_indexed(children, function f_PCT_(idx, item) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
confirm_child(item);
return $calcit._$L_(idx, item)
}
), val_exists_$q_);
return $calcit._$n__PCT__$M_($respo_DOT_schema.Element, _kwd["name"], tag_name, _kwd["coord"], null, _kwd["attrs"], attrs, _kwd["style"], styles, _kwd["event"], event, _kwd["children"], children_nodes)

}
export function span(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_kwd["span"], props, ...$calcit.listToArray(children))
}
export function _LT__GT_(content, style) { 
if (arguments.length < 1) throw new Error('too few arguments');
if (arguments.length > 2) throw new Error('too many arguments');

if ($calcit.string_$q_(style)) { return span($calcit._$n__$M_(_kwd["inner-text"], content, _kwd["class-name"], style)) }else { return span($calcit._$n__$M_(_kwd["inner-text"], content, _kwd["style"], style)) }
}
export function a(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_kwd["a"], props, ...$calcit.listToArray(children))
}
export function body(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_kwd["body"], props, ...$calcit.listToArray(children))
}
export function confirm_child_pair(pair) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('confirm-child-pair', 1, arguments.length);
(function __fn__(){
( $calcit.not($calcit.string_$q_("expected pair")) ? (function __fn__(){
let err_AUTO_3 = new Error("expects 1st argument to be string");
 err_AUTO_3.data = null;
 throw err_AUTO_3;
})() : null );

if (( $calcit.list_$q_(pair) ? (function __fn__(){
let v1__6 = $calcit._$n__$e_(2, $calcit.count(pair));

if (v1__6) { return v1__6 }else { return false }

})() : false )) { return null }else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("and"), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("list?"), new $calcit.CalcitSymbol("pair")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("&="), 2, new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("count"), new $calcit.CalcitSymbol("pair")])])]))));
let err_AUTO_4 = new Error("expected pair (and (list? pair) (&= 2 (count pair)))");
 err_AUTO_4.data = null;
 throw err_AUTO_4;
 }

})();
(function __fn__(){
let x = $calcit.nth(pair, 1);
( $calcit.not($calcit.string_$q_("Invalid data in elements tree: ")) ? (function __fn__(){
let err_AUTO_5 = new Error("expects 1st argument to be string");
 err_AUTO_5.data = null;
 throw err_AUTO_5;
})() : null );

if ((function __fn__(){
let v1__7 = $calcit.nil_$q_(x);

if ($calcit.nil_$q_(v1__7)) { let v1__8 = element_$q_(x);

if ($calcit.nil_$q_(v1__8)) { return component_$q_(x) }
 else if ($calcit._$e_(false, v1__8)) { return component_$q_(x) }else { return v1__8 }
 }
 else if ($calcit._$e_(false, v1__7)) { let v1__9 = element_$q_(x);

if ($calcit.nil_$q_(v1__9)) { return component_$q_(x) }
 else if ($calcit._$e_(false, v1__9)) { return component_$q_(x) }else { return v1__9 }
 }else { return v1__7 }

})()) { return null }else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("or"), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("nil?"), new $calcit.CalcitSymbol("x")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("element?"), new $calcit.CalcitSymbol("x")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("component?"), new $calcit.CalcitSymbol("x")])]))));
let err_AUTO_6 = new Error("Invalid data in elements tree:  (or (nil? x) (element? x) (component? x))");
 err_AUTO_6.data = null;
 throw err_AUTO_6;
 }


})();
return pair
}
export function create_list_element(tag_name, props, child_map) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('create-list-element', 3, arguments.length);
let attrs = pick_attrs(props);
let styles = $calcit.sort($calcit.invoke_method("to-list",(function __fn__(){
let v1__5 = $calcit.get(props, _kwd["style"]);

if ($calcit.nil_$q_(v1__5)) { return $calcit._$n__$M_() }else { return v1__5 }

})(),), function f_PCT_(x, y) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit._$n_compare($calcit.first(x), $calcit.first(y))
}
);
let event = pick_event(props);
return $calcit._$n__PCT__$M_($respo_DOT_schema.Element, _kwd["name"], tag_name, _kwd["coord"], null, _kwd["attrs"], attrs, _kwd["style"], styles, _kwd["event"], event, _kwd["children"], $calcit.map(child_map, confirm_child_pair))

}
export function div(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_kwd["div"], props, ...$calcit.listToArray(children))
}
export function extract_effects_list(markup) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('extract-effects-list', 1, arguments.length);
let markup_tree = $calcit.get(markup, _kwd["tree"]);

if ($calcit.nil_$q_(markup_tree)) { return $calcit.assoc(markup, _kwd["tree"], span(null)) }
 else if ($calcit.list_$q_(markup_tree)) { let node_tree = $calcit.find(markup_tree, function f_PCT_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);

if ($calcit.record_$q_(x)) { let v1__10 = (function __fn__(){
let v1__11 = component_$q_(x);

if ($calcit.nil_$q_(v1__11)) { return element_$q_(x) }
 else if ($calcit._$e_(false, v1__11)) { return element_$q_(x) }else { return v1__11 }

})();

if (v1__10) { return v1__10 }else { return false }
 }else { return false }
}
);
let effects_list = $calcit.filter(markup_tree, effect_$q_);
return $calcit.assoc($calcit.assoc(markup, _kwd["tree"], node_tree), _kwd["effects"], effects_list)
 }else { return markup }

}
export function head(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_kwd["head"], props, ...$calcit.listToArray(children))
}
export function html(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_kwd["html"], props, ...$calcit.listToArray($calcit.map(children, confirm_child)))
}
export function link(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_kwd["link"], props, ...$calcit.listToArray(children))
}
export function list__GT_(props, children) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('list->', 2, arguments.length);
return create_list_element(_kwd["div"], props, children)
}



