
import * as $calcit from "./calcit.core.mjs";
import { dashed__GT_camel } from "./respo.util.format.mjs";
import { get_style_value } from "./respo.util.format.mjs";
import { mute_element } from "./respo.util.format.mjs";
import { prop__GT_attr } from "./respo.util.format.mjs";
import { purify_element } from "./respo.util.format.mjs";
import { text__GT_html } from "./respo.util.format.mjs";
var _kwd={};
["attrs","children","inner-text","innerHTML","name","style","textarea","value",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function escape_html(text) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('escape-html', 1, arguments.length);

if ($calcit.nil_$q_(text)) { return "" }else { return $calcit.invoke_method("replace",$calcit.invoke_method("replace",$calcit.invoke_method("replace",$calcit.invoke_method("replace",text,"\"", "&quot;"),"<", "&lt;"),">", "&gt;"),"\n", "&#13;&#10;") }
}
export function style__GT_string(styles) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('style->string', 1, arguments.length);
return $calcit.join_str($calcit.map(styles, function f_PCT_(entry) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
let k = $calcit.first(entry);
let style_name = $calcit.turn_string(k);
let v = get_style_value($calcit.last(entry), dashed__GT_camel(style_name));
return $calcit.str(style_name, ":", escape_html(v), ";")

}
), "")
}
export function entry__GT_string(entry) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('entry->string', 1, arguments.length);
let k = $calcit.first(entry);
let v = $calcit.last(entry);
return $calcit.str(prop__GT_attr($calcit.turn_string(k)), "=", $calcit.invoke_method("escape",(function __fn__(){

if ($calcit._$e_(k, _kwd["style"])) { return style__GT_string(v) }
 else if ($calcit.bool_$q_(v)) { return $calcit.str(v) }
 else if ($calcit.number_$q_(v)) { return $calcit.str(v) }
 else if ($calcit.keyword_$q_(v)) { return $calcit.turn_string(v) }
 else if ($calcit.string_$q_(v)) { return escape_html(v) }else { return $calcit.str(v) }
})(),))

}
export function props__GT_string(props) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('props->string', 1, arguments.length);
return $calcit.join_str($calcit.map($calcit.filter($calcit.invoke_method("to-list",props,), function f_PCT_(pair) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
let k = $calcit.first(pair);
let v = $calcit.last(pair);

if ($calcit.some_$q_(v)) { let v1__3 = $calcit.not($calcit.starts_with_$q_($calcit.turn_string(k), "on-"));

if (v1__3) { return v1__3 }else { return false }
 }else { return false }

}
), entry__GT_string), " ")
}
export function element__GT_string(element) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('element->string', 1, arguments.length);
let tag_name = $calcit.turn_string($calcit.get(element, _kwd["name"]));
let attrs = $calcit.pairs_map($calcit.get(element, _kwd["attrs"]));
let styles = (function __fn__(){
let v1__1 = $calcit.get(element, _kwd["style"]);

if ($calcit.nil_$q_(v1__1)) { return $calcit._$n__$M_() }else { return v1__1 }

})();
let text_inside = ( $calcit._$e_($calcit.get(element, _kwd["name"]), _kwd["textarea"]) ? escape_html($calcit.get(attrs, _kwd["value"])) : (function __fn__(){
let v1__2 = $calcit.get(attrs, _kwd["innerHTML"]);

if ($calcit.nil_$q_(v1__2)) { return text__GT_html($calcit.get(attrs, _kwd["inner-text"])) }else { return v1__2 }

})() );
let tailored_props = (function __fn__(){
let props = $calcit.dissoc($calcit.dissoc(attrs, _kwd["innerHTML"]), _kwd["inner-text"]);

if ($calcit.empty_$q_(styles)) { return props }else { return $calcit.assoc(props, _kwd["style"], styles) }

})();
let props_in_string = props__GT_string(tailored_props);

if ($calcit._$n_set_$o_includes_$q_(self_closing, tag_name)) { return $calcit.str("<", tag_name, ( $calcit.blank_$q_(props_in_string) ? "" : " " ), props_in_string, " >") }else { let children = $calcit.map($calcit.get(element, _kwd["children"]), function f_PCT_(entry) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
let child = $calcit.last(entry);
return element__GT_string(child)

}
);
return $calcit.str("<", tag_name, ( $calcit.blank_$q_(props_in_string) ? "" : " " ), props_in_string, ">", ( $calcit.nil_$q_(text_inside) ? $calcit.join_str(children, "") : text_inside ), "</", tag_name, ">")
 }

}
export function make_string(element) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('make-string', 1, arguments.length);
return element__GT_string(purify_element(mute_element(element)))
}



export var self_closing = $calcit._SHA__$M_("area", "base", "br", "col", "embed", "hr", "img", "input", "link", "meta", "param", "source", "track", "wbr");

