
import * as $calcit from "./calcit.core.mjs";
var _kwd={};
["Component","Effect","Element","args","attrs","children","coord","effects","event","method","name","style","tree",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};




export var Component = $calcit.new_record(_kwd["Component"], _kwd["name"], _kwd["effects"], _kwd["tree"]);

export var Effect = $calcit.new_record(_kwd["Effect"], _kwd["name"], _kwd["coord"], _kwd["args"], _kwd["method"]);

export var Element = $calcit.new_record(_kwd["Element"], _kwd["name"], _kwd["coord"], _kwd["attrs"], _kwd["style"], _kwd["event"], _kwd["children"]);

