
import * as $calcit from "./calcit.core.mjs";
import { component_$q_ } from "./respo.util.detect.mjs";
import { element_$q_ } from "./respo.util.detect.mjs";
var _kwd={};
["children","event","tree",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function dashed__GT_camel(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('dashed->camel', 1, arguments.length);
return x.replace(dashed_letter_pattern, function f_PCT_(cc, pos, prop) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('f%', 3, arguments.length);
return $calcit.aget(cc, 1).toUpperCase()
}
)
}
export function get_style_value(x, prop) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('get-style-value', 2, arguments.length);

if ($calcit.string_$q_(x)) { return x }
 else if ($calcit.keyword_$q_(x)) { return $calcit.turn_string(x) }
 else if ($calcit.number_$q_(x)) { 
if (pattern_non_dimension_props.test(prop)) { return $calcit.str(x) }else { return $calcit.str(x, "px") } }else { return $calcit.str(x) }
}
export function mute_element(element) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('mute-element', 1, arguments.length);

if (component_$q_(element)) { return $calcit.update(element, _kwd["tree"], mute_element) }else { return $calcit.update($calcit.assoc(element, _kwd["event"], $calcit._$n__$M_()), _kwd["children"], function f_PCT_(children) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.map(children, function f_PCT_(entry) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit._$L_($calcit.first(entry), mute_element($calcit.last(entry)))
}
)
}
) }
}
export function prop__GT_attr(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('prop->attr', 1, arguments.length);
( $calcit.includes_$q_(x, "?") ? console.log($calcit.printable("[Respo] warning: property includes `?` in", x)) : null );
let v__1 = x;

if ($calcit._$n__$e_(v__1, "class-name")) { return "class" }
 else if ($calcit._$n__$e_(v__1, "tab-index")) { return "tabindex" }
 else if ($calcit._$n__$e_(v__1, "read-only")) { return "readonly" }else { return x }

}
export function purify_events(events) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('purify-events', 1, arguments.length);
return $calcit.reduce(events, $calcit._$L_(), function f_PCT_(acc, pair) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);

if ($calcit.some_$q_($calcit.last(pair))) { return $calcit.conj(acc, $calcit.first(pair)) }else { return acc }
}
)
}
export function purify_element(markup) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('purify-element', 1, arguments.length);

if ($calcit.nil_$q_(markup)) { return null }
 else if (component_$q_(markup)) { return purify_element((function __fn__(){
let t = $calcit.get(markup, _kwd["tree"]);
( $calcit.nil_$q_(t) ? (function __fn__(){
let err_AUTO_1 = new Error("tree is empty");
 err_AUTO_1.data = null;
 throw err_AUTO_1;
})() : null );
return t

})()) }
 else if (element_$q_(markup)) { return $calcit.update($calcit.update(markup, _kwd["event"], purify_events), _kwd["children"], function f_PCT_(children) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.map(children, function f_PCT_(pair) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
let k = $calcit.first(pair);
let child = $calcit.last(pair);
return $calcit._$L_(k, purify_element(child))

}
)
}
) }else { console.warn("Unknown markup during purify:", markup);
return null
 }
}
export function text__GT_html(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('text->html', 1, arguments.length);

if ($calcit.some_$q_(x)) { return $calcit.invoke_method("replace",$calcit.invoke_method("replace",$calcit.str(x),">", "&gt;"),"<", "&lt;") }else { return null }
}



export var dashed_letter_pattern = new RegExp("-[a-z]", "g");

export var pattern_non_dimension_props = new RegExp("acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|itera", "i");

